#ifndef STORAGE_H
#define STORAGE_H

#include <Arduino.h>
#include <SPIFFS.h>
#include "consts.h"

class Storage
{
public:
  static bool isMounted;
  static void init();
  static void setPID(float kp, float ki, float kd);
  static void getPID(float &kp, float &ki, float &kd);
  static void setSensitivity(unsigned int sensitivity);
  static unsigned int getSensitivity();
  static void setName(String name);
  static String getName();
  static void setTrackingParams(uint8_t baseSpeed, uint8_t turnSpeed, uint8_t rotateSensitive);
  static void getTrackingParams(uint8_t &baseSpeed, uint8_t &turnSpeed, uint8_t &rotateSensitive);
};

#endif
